const replace = require("replace");
const path = require('path');
const apiPath = path.join(__dirname, '../../', 'docs', 'API');
const pretty = require('pretty');
const fs = require('fs');


const files = fs.readdirSync(apiPath);
const replacements = [];
// 目录修改
const replaceDir = [
  {
    find: 'ITUIChatEngine</a>',
    replace: 'TUIChatEngine</a>'
  },
  {
    find: 'ITUIStore</a>',
    replace: 'TUIStore</a>'
  },
  {
    find: '<li><a href="IConversationModel.html">IConversationModel</a>',
    replace: '<li data-type="method" style="display: block;color: hsl(207, 1%, 60%);font-size: 12px;"><span class="nav-separator">----------- TUIModel -----------</span></li><li><a href="IConversationModel.html">ConversationModel</a>'
  },
  {
    find: 'IMessageModel</a>',
    replace: 'MessageModel</a>'
  },
  {
    find: 'IGroupModel</a>',
    replace: 'GroupModel</a>'
  },
  {
    find: '<li><a href="ITUIConversationService.html">ITUIConversationService</a>',
    replace: '<li data-type="method" style="display: block;color: hsl(207, 1%, 60%);font-size: 12px;"><span class="nav-separator">----------- TUIService ----------</span></li><li><a href="ITUIConversationService.html">TUIConversationService</a>'
  },
  {
    find: 'ITUIChatService</a>',
    replace: 'TUIChatService</a>'
  },
  {
    find: 'ITUIGroupService</a>',
    replace: 'TUIGroupService</a>'
  },
  {
    find: 'ITUIUserService</a>',
    replace: 'TUIUserService</a>'
  },
  {
    find: 'ITUIFriendService</a>',
    replace: 'TUIFriendService</a>'
  },
  {
    find: 'ITUITranslateService</a>',
    replace: 'TUITranslateService</a>'
  },
  {
    find: '<li><a href="LoginParams.html">LoginParams</a></li>',
    replace: '<div style="display: none;"><li><a href="LoginParams.html">LoginParams</a></li>'
  },
  {
    find: '<li><a href="DeleteFriendApplicationParams.html">DeleteFriendApplicationParams</a></li>',
    replace: '<li><a href="DeleteFriendApplicationParams.html">DeleteFriendApplicationParams</a></li></div>'
  }
];

replacements.push(
  ...replaceDir,
);

files.forEach(file => {
  if (path.extname(file) === '.html') {
    const htmlPath = path.join(apiPath, file);
    fs.writeFile(htmlPath, pretty(fs.readFileSync(htmlPath).toString()), function (err) {
      if (err) {
        return console.error(err);
      }
      console.log(htmlPath, "success！");
      replacements.forEach(function (obj) {
        replace({
          regex: obj.find,
          replacement: obj.replace,
          paths: [htmlPath],
          recursive: true,
          silent: true
        });
      });
    });
  }
});
