"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
exports.__esModule = true;
var const_1 = require("../const");
var ReadReceiptHandler = /** @class */ (function () {
    function ReadReceiptHandler(TUIChatService) {
        this.TUIChatService = TUIChatService;
    }
    ReadReceiptHandler.prototype.getEngine = function () {
        return this.TUIChatService.getEngine();
    };
    ReadReceiptHandler.prototype.init = function () {
        var chatEngine = this.getEngine();
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_READ_RECEIPT_RECEIVED, this.onMessageReadReceiptReceived.bind(this));
    };
    ReadReceiptHandler.prototype.onMessageReadReceiptReceived = function (readReceiptInfoList) {
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, currentConversationID, messageList;
            var _this = this;
            return __generator(this, function (_a) {
                chatEngine = this.getEngine();
                currentConversationID = chatEngine.TUIStore.getData(const_1.StoreName.CONV, 'currentConversationID');
                messageList = [];
                readReceiptInfoList.forEach(function (item) { return __awaiter(_this, void 0, void 0, function () {
                    var messageID, message;
                    return __generator(this, function (_a) {
                        switch (_a.label) {
                            case 0:
                                messageID = item.messageID;
                                return [4 /*yield*/, chatEngine.chat.findMessage(messageID)];
                            case 1:
                                message = _a.sent();
                                // 只更新当前会话的已读回执信息
                                if (message && (currentConversationID === message.conversationID)) {
                                    messageList.push(message);
                                }
                                return [2 /*return*/];
                        }
                    });
                }); });
                if (messageList.length > 0) {
                    chatEngine.TUIChat.updateMessageList(messageList, 'edit');
                }
                return [2 /*return*/];
            });
        });
    };
    ReadReceiptHandler.prototype.sendMessageReadReceipt = function (messageList) {
        var list = [];
        messageList.forEach(function (messageModel) {
            var message = messageModel.getMessage();
            list.push(message);
        });
        return this.getEngine().chat.sendMessageReadReceipt(list);
    };
    ReadReceiptHandler.prototype.getGroupMessageReadMemberList = function (options) {
        var message = options.message.getMessage();
        var params = __assign(__assign({}, options), { message: message });
        return this.getEngine().chat.getGroupMessageReadMemberList(params);
    };
    ReadReceiptHandler.prototype.getMessageReadReceiptList = function (messageList) {
        var _this = this;
        var chatEngine = this.getEngine();
        var enabledMessageReadReceipt = chatEngine.TUIStore.getData(const_1.StoreName.APP, 'enabledMessageReadReceipt');
        var displayMessageReadReceipt = chatEngine.TUIStore.getData(const_1.StoreName.USER, 'displayMessageReadReceipt');
        // 处理以下case:
        // case1: 业务侧不需要单条已读回执功能
        // case2: UI 层没有开启消息阅读状态展示时不需要获取已读回执信息
        // case3: messageList 为空时直接返回
        // case4: C2C 拉漫游时已经返回了已读回执信息，只需要单独获取群的已读回执信息
        var flag = !enabledMessageReadReceipt
            || !displayMessageReadReceipt
            || (messageList.length === 0)
            || (messageList[0].conversationType !== chatEngine.TYPES.CONV_GROUP);
        if (!flag) {
            chatEngine.chat.getMessageReadReceiptList(messageList).then(function (imResponse) {
                var newMessageList = imResponse.data.messageList;
                _this.TUIChatService.updateMessageList(newMessageList, 'edit');
            })["catch"](function (error) {
                console.warn("ReadReceiptHandler.getMessageReadReceiptList error:" + error.message);
            });
        }
    };
    return ReadReceiptHandler;
}());
exports["default"] = ReadReceiptHandler;
