"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
var tui_base_1 = require("../tui-base");
var message_handler_1 = require("./message-handler");
var typing_handler_1 = require("./typing-handler");
var read_receipt_handler_1 = require("./read-receipt-handler");
var common_utils_1 = require("../utils/common-utils");
var const_1 = require("../const");
var is_empty_1 = require("../utils/is-empty");
var message_1 = require("../model/message");
var TUIChatService = /** @class */ (function (_super) {
    __extends(TUIChatService, _super);
    function TUIChatService() {
        var _this = _super.call(this) || this;
        _this.serv = 'TUIChatService';
        _this.messageHandler = new message_handler_1["default"](_this);
        _this.typingHandler = new typing_handler_1["default"](_this);
        _this.readReceiptHandler = new read_receipt_handler_1["default"](_this);
        _this.isSwitching = true;
        _this.delayGetHoppingFunction = undefined;
        _this.hoppingConfigMap = new Map();
        return _this;
    }
    /**
     * 获取 TUIChatService 实例
    */
    TUIChatService.getInstance = function () {
        if (!TUIChatService.instance) {
            TUIChatService.instance = new TUIChatService();
        }
        return TUIChatService.instance;
    };
    TUIChatService.prototype.init = function () {
        var chatEngine = this.getEngine();
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_RECEIVED, this.onMessageReceived.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_MODIFIED, this.onMessageModified.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_REVOKED, this.onMessageRevoked.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_READ_BY_PEER, this.onMessageReadByPeer.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_DOWNLOAD_PROGRESS, this.onMessageDownloadProgress.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_REACTIONS_UPDATED, this.onMessageReactionsUpdated.bind(this));
        this.onCurrentConversationIDUpdated();
        this.onMessageSource();
        this.readReceiptHandler.init();
    };
    TUIChatService.prototype.onMessageReceived = function (messageList) {
        this.updateMessageList(messageList, 'received');
        // 提供给 TUINotification 组件使用（即时消费，Store 不存储）
        this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'newMessageList', messageList);
    };
    TUIChatService.prototype.onMessageModified = function (messageList) {
        this.updateMessageList(messageList, 'edit');
    };
    TUIChatService.prototype.onMessageRevoked = function (messageList) {
        this.updateMessageList(messageList, 'edit');
    };
    TUIChatService.prototype.onMessageReadByPeer = function (cleanInfo) {
        var timestamp = cleanInfo.timestamp, conversationID = cleanInfo.conversationID;
        var msgList = this.getStoreData(const_1.StoreName.CHAT, 'messageList').filter(function (item) { return item.time <= timestamp && item.conversationID === conversationID; });
        msgList.forEach(function (item) {
            item.isPeerRead = true;
        });
        this.updateMessageList(msgList, 'edit');
    };
    TUIChatService.prototype.onMessageDownloadProgress = function (progressInfo) {
        if (progressInfo.isFinish) {
            var cacheMap = this.getStoreData(const_1.StoreName.CHAT, "cacheMap");
            var matchStr = progressInfo.msgID + (progressInfo.isSnapshot ? "_S" : "");
            cacheMap.set(matchStr, "file://" + progressInfo.path);
            this.getEngine().TUIStore.update(const_1.StoreName.CHAT, "cacheMap", cacheMap);
        }
    };
    TUIChatService.prototype.onMessageReactionsUpdated = function (data) {
        this.updateMessageReactionList([data]);
    };
    TUIChatService.prototype.onCurrentConversationIDUpdated = function () {
        var _this = this;
        var chatEngine = this.getEngine();
        chatEngine.TUIStore.watch(const_1.StoreName.CONV, {
            currentConversationID: function (conversationID) {
                // 记录切换会话开始状态
                _this.isSwitching = true;
                _this.delayGetHoppingFunction = undefined;
                _this.hoppingConfigMap.clear();
                // conversation 切换, 需重置 chat 数据
                chatEngine.TUIStore.reset(const_1.StoreName.CHAT);
                _this.typingHandler.clearTypingStatus();
                _this.typingHandler.sendTypingEnd();
                // todo 此处特化处理，防止在 switch conversation 的时候调用用户页面还没打开，导致事件没监听
                // 注： 此时 Chat Store 内的数值已经在 conversation 模块被 reset
                if (!is_empty_1["default"](conversationID)) {
                    _this.getMessageList()["finally"](function () {
                        // 切换会话完成
                        _this.isSwitching = false;
                        _this.delayGetHoppingFunction && _this.delayGetHoppingFunction();
                    });
                }
            }
        });
    };
    TUIChatService.prototype.onMessageSource = function () {
        var _this = this;
        var chatEngine = this.getEngine();
        chatEngine.TUIStore.watch(const_1.StoreName.CHAT, {
            messageSource: function (targetMessage) {
                var currentConversationID = _this.getStoreData(const_1.StoreName.CONV, 'currentConversationID');
                // 当前没有打开会话或搜索的消息不在当前会话中，不进行 messageList 切换
                if (!currentConversationID || (targetMessage && targetMessage.conversationID !== currentConversationID)) {
                    return;
                }
                // targetMessage === undefined 有两种情况，1.切换会话; 2.回到最新消息
                if (common_utils_1.isUndefined(targetMessage)) {
                    _this.hoppingConfigMap.clear();
                    chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'messageList', []);
                    chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'nextReqMessageID', '');
                    chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'isCompleted', false);
                    _this.getMessageList();
                    return;
                }
                var currentMessageList = _this.getStoreData(const_1.StoreName.CHAT, 'messageList');
                var message = currentMessageList && currentMessageList.find(function (item) { return targetMessage && item.ID === targetMessage.ID; });
                if (message) {
                    return;
                }
                // 防止切换会话，getMessageList 没有执行完成，再执行 getMessageListHopping 会导致 messageList 错乱
                if (_this.isSwitching) {
                    _this.delayGetHoppingFunction = _this.getMessageListHoppingForDown;
                    return;
                }
                _this.getMessageListHoppingForDown();
            }
        });
    };
    TUIChatService.prototype.getMessageListHoppingForDown = function () {
        var currentMessageList = this.getStoreData(const_1.StoreName.CHAT, 'messageList');
        var _a = this.getStoreData(const_1.StoreName.CHAT, 'messageSource'), conversationID = _a.conversationID, sequence = _a.sequence, time = _a.time, ID = _a.ID;
        var message = currentMessageList && currentMessageList.find(function (item) { return ID && item.ID === ID; });
        if (message) {
            return;
        }
        var chatEngine = this.getEngine();
        chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'messageList', []);
        chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'nextReqMessageID', '');
        chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'isCompleted', false);
        this.getMessageListHopping({ conversationID: conversationID, sequence: sequence, time: time, direction: 1 });
    };
    /**
     * 私有方法，获取 store data
    */
    TUIChatService.prototype.getStoreData = function (storeName, key) {
        return this.getEngine().TUIStore.getData(storeName, key);
    };
    /**
     * 私有方法，调用 TIM 接口发送消息
     * @param {Message} message 要发送的 message
     * @param {SendMessageOptions} [options] 消息发送选项
     * @returns {Promise<any>} im 接口的 response 原样返回
     *
     */
    TUIChatService.prototype.sendMessage = function (message, options) {
        this.updateMessageList([message], 'send'); // 不论成功失败，先消息上屏，更新 UI
        var promise = this.getEngine().chat.sendMessage(message, options);
        return this.getResponse(promise);
    };
    /**
     * 私有方法，用于 messageList 状态变更并 return
     * @param {Promise} promise 调用 im 接口返回的 promise
     * @param {boolean} success 成功回调是否更新数据
     * @param {boolean} fail 失败回调是否更新数据
     * @returns {Promise<any>} im 接口的 response 原样返回
     */
    TUIChatService.prototype.getResponse = function (promise, success, fail) {
        var _this = this;
        if (success === void 0) { success = true; }
        if (fail === void 0) { fail = true; }
        return promise
            .then(function (imResponse) {
            var messageList = imResponse.data.messageList ? imResponse.data.messageList : [imResponse.data.message];
            success && _this.updateMessageList(messageList, 'edit');
            return imResponse;
        })["catch"](function (error) {
            var _a;
            fail && ((_a = error === null || error === void 0 ? void 0 : error.data) === null || _a === void 0 ? void 0 : _a.message) && _this.updateMessageList([error.data.message], 'edit');
            return Promise.reject(error);
        });
    };
    TUIChatService.prototype.updateMessageList = function (messageList, type) {
        if (type === void 0) { type = ''; }
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, currentMessageList, tempMessageList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        if (this.getStoreData(const_1.StoreName.CHAT, 'messageSource') && type !== 'unshift' && type !== 'edit') {
                            return [2 /*return*/];
                        }
                        chatEngine = this.getEngine();
                        messageList.map(function (item) {
                            if ([chatEngine.TYPES.MSG_AUDIO, chatEngine.TYPES.MSG_FILE, chatEngine.TYPES.MSG_IMAGE, chatEngine.TYPES.MSG_VIDEO].includes(item.type)) {
                                chatEngine.chat.downloadMessage(item);
                            }
                        });
                        currentMessageList = this.getStoreData(const_1.StoreName.CHAT, 'messageList');
                        return [4 /*yield*/, this.updateTargetMessageList(messageList, currentMessageList, type)];
                    case 1:
                        tempMessageList = _a.sent();
                        chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'messageList', tempMessageList);
                        return [2 /*return*/];
                }
            });
        });
    };
    TUIChatService.prototype.updateTargetMessageList = function (newMessageList, target, type) {
        if (type === void 0) { type = ''; }
        return __awaiter(this, void 0, void 0, function () {
            var conversationID, toBeUpdatedMessageList, currentMessageList, tempMessageList, userInfo, _loop_1, _i, target_1, currentMessage;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        conversationID = this.getStoreData(const_1.StoreName.CONV, 'currentConversationID');
                        toBeUpdatedMessageList = newMessageList.filter(function (item) { return item.conversationID === conversationID; });
                        return [4 /*yield*/, this.handleC2CCallSignaling(toBeUpdatedMessageList)];
                    case 1:
                        // handle call signaling message
                        toBeUpdatedMessageList = _a.sent();
                        if (!type || toBeUpdatedMessageList.length === 0)
                            return [2 /*return*/, target];
                        currentMessageList = target || [];
                        tempMessageList = [];
                        // When Chat is integrated into Room, it needs to be updated.
                        if (type === 'send' || type === 'push') {
                            userInfo = this.getStoreData(const_1.StoreName.CHAT, 'userInfo');
                            if (Object.keys(userInfo).length > 0) {
                                this.updateLocalMessage(toBeUpdatedMessageList, userInfo);
                            }
                        }
                        switch (type) {
                            case 'edit':
                                _loop_1 = function (currentMessage) {
                                    var message = toBeUpdatedMessageList.find(function (m) { return m.ID === currentMessage.ID || (m.localID !== "" && m.localID === currentMessage.localID); });
                                    var temp = message || currentMessage;
                                    if (!temp.isDeleted) {
                                        tempMessageList.push(temp);
                                    }
                                };
                                for (_i = 0, target_1 = target; _i < target_1.length; _i++) {
                                    currentMessage = target_1[_i];
                                    _loop_1(currentMessage);
                                }
                                break;
                            case 'resend':
                                // Resending message is not typing and only one message
                                tempMessageList = currentMessageList.filter(function (message) { return message.ID !== toBeUpdatedMessageList[0].ID; }).concat(toBeUpdatedMessageList);
                                break;
                            case 'send':
                                tempMessageList = currentMessageList.concat(this.typingHandler.filterTypingMessage(toBeUpdatedMessageList));
                                break;
                            case 'push':
                                // message from call or room
                                tempMessageList = currentMessageList.concat(this.typingHandler.filterTypingMessage(toBeUpdatedMessageList));
                                this.getEngine().chat.setMessageRead({ conversationID: conversationID });
                                break;
                            case 'received':
                                // message from MESSAGE_RECEIVED
                                tempMessageList = currentMessageList.concat(this.typingHandler.filterTypingMessage(toBeUpdatedMessageList));
                                tempMessageList = this.sortMessageList(tempMessageList);
                                this.getEngine().chat.setMessageRead({ conversationID: conversationID });
                                break;
                            case 'unshift':
                                // Deduplicate the data in the Store when pulling roaming
                                tempMessageList = toBeUpdatedMessageList.filter(function (message) { return ((currentMessageList.length === 0)
                                    || !currentMessageList.find(function (m) { return m.ID === message.ID; })); });
                                tempMessageList.push.apply(tempMessageList, currentMessageList);
                                tempMessageList = this.sortMessageList(tempMessageList);
                                break;
                            default:
                                break;
                        }
                        return [2 /*return*/, tempMessageList];
                }
            });
        });
    };
    TUIChatService.prototype.enterTypingState = function () {
        var enableTyping = this.getStoreData(const_1.StoreName.APP, 'enableTyping');
        if (enableTyping) {
            this.sendTyping(true);
        }
    };
    TUIChatService.prototype.leaveTypingState = function () {
        var enableTyping = this.getStoreData(const_1.StoreName.APP, 'enableTyping');
        if (enableTyping) {
            this.sendTyping(false);
        }
    };
    TUIChatService.prototype.sendTyping = function (status) {
        var chatEngine = this.getEngine();
        var currentConversationID = this.getStoreData(const_1.StoreName.CONV, 'currentConversationID');
        if (!currentConversationID.startsWith(chatEngine.TYPES.CONV_C2C))
            return;
        var to = currentConversationID.replace(chatEngine.TYPES.CONV_C2C, '');
        if (status) {
            var messageList = this.getStoreData(const_1.StoreName.CHAT, 'messageList');
            var receivedMessageList = messageList.filter(function (item) { return item.flow === 'in'; });
            if (receivedMessageList.length === 0)
                return;
            var latestMessageTime = receivedMessageList[receivedMessageList.length - 1].time * 1000;
            var nowTime = new Date().getTime();
            var diff = nowTime - latestMessageTime;
            if (diff > 1000 * 30)
                return;
        }
        this.typingHandler.sendTyping(status, to);
    };
    TUIChatService.prototype.quoteMessage = function (message) {
        var _a;
        this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'quoteMessage', {
            message: message,
            type: 'quote'
        });
        (_a = this.getEngine().TUIReport) === null || _a === void 0 ? void 0 : _a.reportFeature(205);
        return message;
    };
    TUIChatService.prototype.replyMessage = function (message) {
        this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'quoteMessage', {
            message: message,
            type: 'reply'
        });
        return message;
    };
    TUIChatService.prototype.getCurrentConvInfo = function () {
        var _a = this.getStoreData(const_1.StoreName.CONV, 'currentConversation') || {}, _b = _a.conversationID, conversationID = _b === void 0 ? '' : _b, type = _a.type;
        var to = conversationID.replace(type, '');
        return {
            to: to,
            conversationType: type
        };
    };
    TUIChatService.prototype.t = function (text) {
        return this.getEngine().TUITranslate.t(text) || text;
    };
    TUIChatService.prototype.getMessageAbstractAndType = function (message) {
        var _a, _b;
        var chatEngine = this.getEngine();
        var data = {
            abstract: '',
            type: 0
        };
        // 对齐 native, abstract 不传
        // 兼容低版本，已传入的 abstract 不进行调整，新增的不传 abstract
        switch (message.type) {
            case chatEngine.TYPES.MSG_TEXT:
                data.abstract = (_a = message === null || message === void 0 ? void 0 : message.payload) === null || _a === void 0 ? void 0 : _a.text;
                data.type = 1;
                break;
            case chatEngine.TYPES.MSG_CUSTOM:
                data.abstract = '[自定义消息]';
                data.type = 2;
                break;
            case chatEngine.TYPES.MSG_IMAGE:
                data.abstract = '[图片]';
                data.type = 3;
                break;
            case chatEngine.TYPES.MSG_AUDIO:
                data.abstract = '[语音]';
                data.type = 4;
                break;
            case chatEngine.TYPES.MSG_VIDEO:
                data.abstract = '[视频]';
                data.type = 5;
                break;
            case chatEngine.TYPES.MSG_FILE:
                data.abstract = '[文件]';
                data.type = 6;
                break;
            case chatEngine.TYPES.MSG_LOCATION:
                data.type = 7;
                break;
            case chatEngine.TYPES.MSG_FACE:
                data.abstract = '[表情]';
                data.type = 8;
                break;
            case chatEngine.TYPES.MSG_GRP_TIP:
                data.type = 9;
                break;
            case chatEngine.TYPES.MSG_MERGER:
                data.abstract = (_b = message === null || message === void 0 ? void 0 : message.payload) === null || _b === void 0 ? void 0 : _b.title;
                data.type = 10;
                break;
            default:
                break;
        }
        return data;
    };
    /**
     *  - 注意: 暂只支持文本发送时携带引用消息，结构体参考 https://iwiki.woa.com/pages/viewpage.action?pageId=1238962637
     */
    TUIChatService.prototype.genMessageReply = function (message, type) {
        if (type !== 'reply' && type !== 'quote') {
            return {};
        }
        var _a = this.getMessageAbstractAndType(message), abstract = _a.abstract, messageType = _a.type;
        var messageReplyRoot = {
            messageAbstract: abstract,
            messageSender: message.nick || message.from,
            messageID: message.ID
        };
        var messageReply = __assign(__assign({}, messageReplyRoot), { messageType: messageType, messageTime: message === null || message === void 0 ? void 0 : message.time, messageSequence: message === null || message === void 0 ? void 0 : message.sequence, version: 1 });
        if (type === 'reply') {
            messageReply.messageRootID = message.ID;
            if (message.cloudCustomData) {
                var rootCloudCustomData = common_utils_1.JSONToObject(message.cloudCustomData);
                if (rootCloudCustomData.messageReply && rootCloudCustomData.messageReply.messageRootID) {
                    messageReply.messageRootID = rootCloudCustomData.messageReply.messageRootID;
                }
            }
        }
        return {
            messageReply: messageReply,
            messageReplyRoot: messageReplyRoot
        };
    };
    TUIChatService.prototype.getMessageInfo = function (options, message, type) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, messageReply, messageReplyRoot, cloudCustomData, rootMessage, messageRootID, rootCloudCustomData;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        _a = this.genMessageReply(message, type), messageReply = _a.messageReply, messageReplyRoot = _a.messageReplyRoot;
                        cloudCustomData = options.cloudCustomData ? common_utils_1.JSONToObject(options.cloudCustomData) : {};
                        if (cloudCustomData.messageReply) {
                            cloudCustomData.messageReply = __assign(__assign({}, messageReply), cloudCustomData.messageReply);
                        }
                        else {
                            cloudCustomData.messageReply = messageReply;
                        }
                        if (!(type === 'reply')) return [3 /*break*/, 2];
                        messageRootID = messageReply.messageRootID;
                        return [4 /*yield*/, this.getEngine().chat.findMessage(messageRootID)];
                    case 1:
                        rootMessage = _b.sent();
                        rootCloudCustomData = (rootMessage === null || rootMessage === void 0 ? void 0 : rootMessage.cloudCustomData) ? common_utils_1.JSONToObject(rootMessage.cloudCustomData) : {};
                        if (!rootCloudCustomData.messageReplies) {
                            rootCloudCustomData.messageReplies = {};
                        }
                        if (!common_utils_1.isArray(rootCloudCustomData.messageReplies.replies)) {
                            rootCloudCustomData.messageReplies.replies = [];
                        }
                        rootCloudCustomData.messageReplies.replies.push(messageReplyRoot);
                        rootMessage.cloudCustomData = JSON.stringify(rootCloudCustomData);
                        _b.label = 2;
                    case 2: return [2 /*return*/, {
                            cloudCustomData: JSON.stringify(cloudCustomData),
                            rootMessage: rootMessage
                        }];
                }
            });
        });
    };
    TUIChatService.prototype.sendTextMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, _a, quoteMessage, type, quoteInfo, message;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        chatEngine = this.getEngine();
                        _a = this.getStoreData(const_1.StoreName.CHAT, 'quoteMessage'), quoteMessage = _a.message, type = _a.type;
                        quoteInfo = {
                            cloudCustomData: options.cloudCustomData || '',
                            rootMessage: undefined
                        };
                        if (!quoteMessage) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getMessageInfo(options, quoteMessage, type)];
                    case 1:
                        quoteInfo = _b.sent();
                        _b.label = 2;
                    case 2: return [4 /*yield*/, chatEngine.chat.createTextMessage(__assign(__assign(__assign({}, this.getCurrentConvInfo()), options), { cloudCustomData: quoteInfo.cloudCustomData }))];
                    case 3:
                        message = _b.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions).then(function (imResponse) {
                                if (quoteInfo.rootMessage) {
                                    _this.modifyMessage(quoteInfo.rootMessage);
                                }
                                chatEngine.TUIStore.reset(const_1.StoreName.CHAT, ['quoteMessage'], true);
                                return imResponse;
                            })];
                }
            });
        });
    };
    TUIChatService.prototype.sendTextAtMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, _a, quoteMessage, type, quoteInfo, message;
            var _this = this;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        chatEngine = this.getEngine();
                        _a = this.getStoreData(const_1.StoreName.CHAT, 'quoteMessage'), quoteMessage = _a.message, type = _a.type;
                        quoteInfo = {
                            cloudCustomData: options.cloudCustomData || '',
                            rootMessage: undefined
                        };
                        if (!quoteMessage) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getMessageInfo(options, quoteMessage, type)];
                    case 1:
                        quoteInfo = _b.sent();
                        _b.label = 2;
                    case 2: return [4 /*yield*/, chatEngine.chat.createTextAtMessage(__assign(__assign(__assign({}, this.getCurrentConvInfo()), options), { cloudCustomData: quoteInfo.cloudCustomData }))];
                    case 3:
                        message = _b.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions).then(function (imResponse) {
                                if (quoteInfo.rootMessage) {
                                    _this.modifyMessage(quoteInfo.rootMessage);
                                }
                                chatEngine.TUIStore.reset(const_1.StoreName.CHAT, ['quoteMessage'], true);
                                return imResponse;
                            })];
                }
            });
        });
    };
    TUIChatService.prototype.sendImageMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var message;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEngine().chat.createImageMessage(__assign(__assign(__assign({}, this.getCurrentConvInfo()), options), { onProgress: function (progress) {
                                _this.onProgress(message.ID, progress);
                            } }))];
                    case 1:
                        message = _a.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.sendAudioMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var message;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEngine().chat.createAudioMessage(__assign(__assign(__assign({}, this.getCurrentConvInfo()), options), { onProgress: function (progress) {
                                _this.onProgress(message.ID, progress);
                            } }))];
                    case 1:
                        message = _a.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.sendVideoMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var createThumbnail, thumbnailModule, err_1, res, message;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        _a.trys.push([0, 2, , 3]);
                        return [4 /*yield*/, Promise.resolve().then(function () { return require('react-native-create-thumbnail'); })["catch"](function (err) { return null; })];
                    case 1:
                        thumbnailModule = _a.sent();
                        if (thumbnailModule == null) {
                            console.log("Need install react-native-create-thumbnail");
                            return [2 /*return*/, null];
                        }
                        createThumbnail = thumbnailModule.createThumbnail;
                        return [3 /*break*/, 3];
                    case 2:
                        err_1 = _a.sent();
                        console.warn('Optional dependency "react-native-create-thumbnail" not installed. Thumbnail generation will be skipped.');
                        createThumbnail = null;
                        return [3 /*break*/, 3];
                    case 3:
                        if (createThumbnail == null) {
                            console.log("Need install react-native-create-thumbnail");
                            return [2 /*return*/, null];
                        }
                        return [4 /*yield*/, createThumbnail({
                                url: options.payload.file.uri,
                                cacheName: String(Date.now()),
                                format: "png"
                            })["catch"](function (err) {
                                console.log("生成封面失败：", err);
                                return null;
                            })];
                    case 4:
                        res = _a.sent();
                        if (!res)
                            return [2 /*return*/];
                        options.payload.file.snapshotPath = res.path;
                        return [4 /*yield*/, this.getEngine().chat.createVideoMessage(__assign(__assign(__assign({}, this.getCurrentConvInfo()), options), { onProgress: function (progress) {
                                    _this.onProgress(message.ID, progress);
                                } }))];
                    case 5:
                        message = _a.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.sendCustomMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEngine().chat.createCustomMessage(__assign(__assign({}, this.getCurrentConvInfo()), options))];
                    case 1:
                        message = _a.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.sendFaceMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEngine().chat.createFaceMessage(__assign(__assign({}, this.getCurrentConvInfo()), options))];
                    case 1:
                        message = _a.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.sendFileMessage = function (options, sendMessageOptions) {
        var _a, _b, _c;
        return __awaiter(this, void 0, void 0, function () {
            var message;
            var _this = this;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        options.payload.file.uri = (_c = (_b = (_a = options === null || options === void 0 ? void 0 : options.payload) === null || _a === void 0 ? void 0 : _a.file) === null || _b === void 0 ? void 0 : _b.fileCopyUri) !== null && _c !== void 0 ? _c : "";
                        return [4 /*yield*/, this.getEngine().chat.createFileMessage(__assign(__assign(__assign({}, this.getCurrentConvInfo()), options), { onProgress: function (progress) {
                                    _this.onProgress(message.ID, progress);
                                } }))];
                    case 1:
                        message = _d.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.sendLocationMessage = function (options, sendMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var message;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getEngine().chat.createLocationMessage(__assign(__assign({}, this.getCurrentConvInfo()), options))];
                    case 1:
                        message = _a.sent();
                        return [2 /*return*/, this.sendMessage(message, sendMessageOptions)];
                }
            });
        });
    };
    TUIChatService.prototype.onProgress = function (messageID, progress) {
        var message = this.getEngine().TUIStore.getMessageModel(messageID);
        if (message) {
            // 避免频繁触发 messageList 更新
            var diff = progress - message.progress;
            if (diff >= 0.1 || progress === 1) {
                message.progress = progress;
                this.updateMessageList([message], 'edit');
            }
        }
    };
    TUIChatService.prototype.setAbstractList = function (message) {
        var chatEngine = this.getEngine();
        var nick = message.nick || message.from;
        var text = '';
        switch (message.type) {
            case chatEngine.TYPES.MSG_TEXT:
                text = message.payload.text || '';
                if (text.length > 20) {
                    text = text.slice(0, 20);
                }
                break;
            case chatEngine.TYPES.MSG_MERGER:
                text = "" + this.t('TUIChat.[聊天记录]');
                break;
            case chatEngine.TYPES.MSG_IMAGE:
                text = "" + this.t('TUIChat.[图片]');
                break;
            case chatEngine.TYPES.MSG_AUDIO:
                text = "" + this.t('TUIChat.[音频]');
                break;
            case chatEngine.TYPES.MSG_VIDEO:
                text = "" + this.t('TUIChat.[视频]');
                break;
            case chatEngine.TYPES.MSG_CUSTOM:
                text = "" + this.t('TUIChat.[自定义消息]');
                break;
            case chatEngine.TYPES.MSG_FILE:
                text = "" + this.t('TUIChat.[文件]');
                break;
            case chatEngine.TYPES.MSG_FACE:
                text = "" + this.t('TUIChat.[动画表情]');
                break;
            default:
                break;
        }
        return nick + ": " + text;
    };
    TUIChatService.prototype.genMergerForwardPayload = function (messageList, mergeInfo) {
        var _this = this;
        var _a = mergeInfo.abstractList, abstractList = _a === void 0 ? [] : _a, _b = mergeInfo.compatibleText, compatibleText = _b === void 0 ? '' : _b, title = mergeInfo.title;
        if (abstractList.length === 0) {
            messageList.forEach(function (message) {
                abstractList.push(_this.setAbstractList(message));
            });
        }
        return {
            messageList: messageList,
            title: title,
            abstractList: abstractList,
            compatibleText: compatibleText || this.t('TUIChat.请升级IMSDK到v2.10.1或更高版本查看此消息')
        };
    };
    TUIChatService.prototype.genSendMergerForwardMessage = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var conversationList, messageList, params, mergeInfo, sendMessageOptions, promiseList, i, _a, conversationID, type, mergerOptions, message;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        conversationList = options.conversationList, messageList = options.messageList, params = options.params, mergeInfo = options.mergeInfo, sendMessageOptions = options.sendMessageOptions;
                        promiseList = [];
                        i = 0;
                        _b.label = 1;
                    case 1:
                        if (!(i < conversationList.length)) return [3 /*break*/, 4];
                        _a = conversationList[i], conversationID = _a.conversationID, type = _a.type;
                        mergerOptions = __assign({ to: conversationID.replace("" + type, ''), conversationType: type, payload: this.genMergerForwardPayload(messageList, mergeInfo) }, params);
                        return [4 /*yield*/, this.getEngine().chat.createMergerMessage(mergerOptions)];
                    case 2:
                        message = _b.sent();
                        promiseList.push(this.sendMessage(message, sendMessageOptions));
                        _b.label = 3;
                    case 3:
                        i++;
                        return [3 /*break*/, 1];
                    case 4: return [2 /*return*/, promiseList];
                }
            });
        });
    };
    TUIChatService.prototype.genTitle = function (message, toUserNick) {
        var nick = message.nick, from = message.from, to = message.to;
        return (nick || from) + " " + this.t('TUIChat.和') + " " + (toUserNick || to) + " " + this.t('TUIChat.的聊天记录');
    };
    TUIChatService.prototype.genMergeInfo = function (options) {
        var _a;
        return __awaiter(this, void 0, void 0, function () {
            var messageList, mergeInfo, _b, data, error_1;
            return __generator(this, function (_c) {
                switch (_c.label) {
                    case 0:
                        messageList = options.messageList, mergeInfo = options.mergeInfo;
                        if (mergeInfo.title) {
                            return [2 /*return*/, mergeInfo];
                        }
                        if (messageList[0].conversationType === this.getEngine().TYPES.CONV_GROUP) {
                            mergeInfo.title = this.t('TUIChat.群聊的聊天记录');
                            return [2 /*return*/, mergeInfo];
                        }
                        _c.label = 1;
                    case 1:
                        _c.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getEngine().TUIUser.getUserProfile({ userIDList: [messageList[0].to] })];
                    case 2:
                        _b = (_c.sent()).data, data = _b === void 0 ? [] : _b;
                        mergeInfo.title = this.genTitle(messageList[0], (_a = data[0]) === null || _a === void 0 ? void 0 : _a.nick);
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _c.sent();
                        mergeInfo.title = this.genTitle(messageList[0]);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/, mergeInfo];
                }
            });
        });
    };
    TUIChatService.prototype.sendMergerForwardMessage = function (options) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        _a = options;
                        return [4 /*yield*/, this.genMergeInfo(options)];
                    case 1:
                        _a.mergeInfo = _d.sent();
                        _c = (_b = Promise).all;
                        return [4 /*yield*/, this.genSendMergerForwardMessage(options)];
                    case 2: return [2 /*return*/, _c.apply(_b, [_d.sent()])];
                }
            });
        });
    };
    TUIChatService.prototype.getOriginMessageList = function (messageList) {
        return messageList.map(function (item) {
            if (item instanceof message_1["default"]) {
                return item.getMessage();
            }
            return item;
        });
    };
    TUIChatService.prototype.sendForwardMessage = function (conversationList, messageList, sendForwardMessageOptions) {
        return __awaiter(this, void 0, void 0, function () {
            var _a, _b, needMerge, _c, params, _d, mergeInfo, rest, promiseList, i, _e, conversationID, type, options, sendMessageOptions, j, message;
            return __generator(this, function (_f) {
                switch (_f.label) {
                    case 0:
                        messageList = this.getOriginMessageList(messageList);
                        _a = sendForwardMessageOptions || {}, _b = _a.needMerge, needMerge = _b === void 0 ? false : _b, _c = _a.params, params = _c === void 0 ? {} : _c, _d = _a.mergeInfo, mergeInfo = _d === void 0 ? {} : _d, rest = __rest(_a, ["needMerge", "params", "mergeInfo"]);
                        if (needMerge) {
                            return [2 /*return*/, this.sendMergerForwardMessage({
                                    conversationList: conversationList,
                                    messageList: messageList,
                                    params: params,
                                    mergeInfo: mergeInfo,
                                    sendMessageOptions: rest
                                })];
                        }
                        promiseList = [];
                        i = 0;
                        _f.label = 1;
                    case 1:
                        if (!(i < conversationList.length)) return [3 /*break*/, 6];
                        _e = conversationList[i], conversationID = _e.conversationID, type = _e.type;
                        options = __assign({ to: conversationID.replace("" + type, ''), conversationType: type }, params);
                        sendMessageOptions = rest[conversationID] || rest;
                        j = 0;
                        _f.label = 2;
                    case 2:
                        if (!(j < messageList.length)) return [3 /*break*/, 5];
                        Reflect.set(options, 'payload', messageList[j]);
                        return [4 /*yield*/, this.getEngine().chat.createForwardMessage(options)];
                    case 3:
                        message = _f.sent();
                        promiseList.push(this.sendMessage(message, sendMessageOptions));
                        _f.label = 4;
                    case 4:
                        j++;
                        return [3 /*break*/, 2];
                    case 5:
                        i++;
                        return [3 /*break*/, 1];
                    case 6: return [2 /*return*/, Promise.all(promiseList)];
                }
            });
        });
    };
    TUIChatService.prototype.revokeMessage = function (message) {
        var promise = this.getEngine().chat.revokeMessage(message);
        return this.getResponse(promise, true, false);
    };
    TUIChatService.prototype.resendMessage = function (message) {
        message.status = 'unSend';
        this.updateMessageList([message], 'resend');
        var promise = this.getEngine().chat.resendMessage(message);
        return this.getResponse(promise, true, true);
    };
    TUIChatService.prototype.deleteMessage = function (messageList) {
        var promise = this.getEngine().chat.deleteMessage(messageList);
        return this.getResponse(promise, true, false);
    };
    TUIChatService.prototype.setMessageExtensions = function (message, extensions) {
        return this.getEngine().chat.setMessageExtensions(message, extensions);
    };
    TUIChatService.prototype.getMessageExtensions = function (message) {
        return this.getEngine().chat.getMessageExtensions(message);
    };
    TUIChatService.prototype.deleteMessageExtensions = function (message, keyList) {
        return this.getEngine().chat.deleteMessageExtensions(message, keyList);
    };
    TUIChatService.prototype.modifyMessage = function (message) {
        var promise = this.getEngine().chat.modifyMessage(message);
        return this.getResponse(promise, true, false)["catch"](function (error) {
            var _a = error.code, _b = _a.code, code = _b === void 0 ? 0 : _b, _c = _a.data, data = _c === void 0 ? {} : _c;
            if (code === const_1.ERROR_CODE.MSG_MODIFY_CONFLICT) {
                console.warn(const_1.ERROR_MSG.MSG_MODIFY_CONFLICT + " data.message: " + (data === null || data === void 0 ? void 0 : data.message));
            }
            else if (code === const_1.ERROR_CODE.MSG_MODIFY_DISABLED_IN_AVCHATROOM) {
                console.warn(const_1.ERROR_MSG.MSG_MODIFY_DISABLED_IN_AVCHATROOM);
            }
            else if (code === const_1.ERROR_CODE.MODIFY_MESSAGE_NOT_EXIST) {
                console.warn(const_1.ERROR_MSG.MODIFY_MESSAGE_NOT_EXIST);
            }
            throw error;
        });
    };
    TUIChatService.prototype.getMessageList = function (options) {
        var _this = this;
        if (options === void 0) { options = {
            conversationID: this.getStoreData(const_1.StoreName.CONV, 'currentConversationID'),
            nextReqMessageID: this.getStoreData(const_1.StoreName.CHAT, 'nextReqMessageID')
        }; }
        var chatEngine = this.getEngine();
        if (!chatEngine.chat.isReady()) {
            return Promise.reject({
                code: const_1.ERROR_CODE_ENGINE.GET_MSG_LIST_ERROR,
                message: const_1.ERROR_MSG_ENGINE.GET_MSG_LIST_ERROR
            });
        }
        if (this.getStoreData(const_1.StoreName.CHAT, 'isCompleted')) {
            return Promise.resolve({
                data: {
                    messageList: [],
                    nextReqMessageID: '',
                    isCompleted: true
                }
            });
        }
        var messageSource = this.getStoreData(const_1.StoreName.CHAT, 'messageSource');
        var nextMessageSeq = this.hoppingConfigMap.get('nextMessageSeq');
        var nextMessageTime = this.hoppingConfigMap.get('nextMessageTime');
        var isHopping = nextMessageSeq || nextMessageTime;
        if (messageSource && messageSource.conversationID === (options === null || options === void 0 ? void 0 : options.conversationID) && isHopping) {
            return this.getMessageListHopping();
        }
        return chatEngine.chat.getMessageList(options).then(function (imResponse) {
            var _a;
            var _b = imResponse.data, messageList = _b.messageList, nextReqMessageID = _b.nextReqMessageID, isCompleted = _b.isCompleted;
            var userInfo = _this.getStoreData(const_1.StoreName.CHAT, 'userInfo');
            if (Object.keys(userInfo).length > 0) {
                // When Chat is integrated into Room, it needs to be updated.
                _this.updateLocalMessage(messageList, userInfo);
            }
            _this.updateMessageList(messageList, 'unshift');
            chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'nextReqMessageID', nextReqMessageID);
            chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'isCompleted', isCompleted);
            // 异步获取消息回应、群已读回执信息（operationType > 0 说明用户已经不在群组内）
            var conversationID = (_a = messageList[0]) === null || _a === void 0 ? void 0 : _a.conversationID;
            var _c = (_this.getEngine().TUIStore.getConversationModel(conversationID) || {}).operationType, operationType = _c === void 0 ? 0 : _c;
            if (operationType === 0) {
                _this.getMessageReactions({ messageList: messageList });
                _this.readReceiptHandler.getMessageReadReceiptList(messageList);
            }
            return imResponse;
        })["catch"](function (error) { return Promise.reject(error); });
    };
    TUIChatService.prototype.getMessageListHopping = function (options) {
        var _this = this;
        var _a;
        if (options === void 0) { options = {
            conversationID: (_a = this.getStoreData(const_1.StoreName.CHAT, 'messageSource')) === null || _a === void 0 ? void 0 : _a.conversationID,
            sequence: this.hoppingConfigMap.get('nextMessageSeq'),
            time: this.hoppingConfigMap.get('nextMessageTime')
        }; }
        var chatEngine = this.getEngine();
        var promise = chatEngine.chat.getMessageListHopping(options);
        return promise.then(function (imResponse) {
            var _a = imResponse.data, messageList = _a.messageList, nextMessageSeq = _a.nextMessageSeq, nextMessageTime = _a.nextMessageTime, isCompleted = _a.isCompleted;
            var _nextMessageSeq = options.direction === 1 ? options.sequence : nextMessageSeq;
            var _nextMessageTime = options.direction === 1 ? options.time : nextMessageTime;
            _this.updateMessageList(messageList, 'unshift');
            _this.delayGetHoppingFunction = undefined;
            _this.hoppingConfigMap.set('nextMessageSeq', _nextMessageSeq);
            _this.hoppingConfigMap.set('nextMessageTime', _nextMessageTime);
            chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'isCompleted', isCompleted);
            return imResponse;
        })["catch"](function (error) { return Promise.reject(error); });
    };
    TUIChatService.prototype.sendMessageReadReceipt = function (messageList) {
        return this.readReceiptHandler.sendMessageReadReceipt(messageList);
    };
    TUIChatService.prototype.getGroupMessageReadMemberList = function (options) {
        var _this = this;
        return this.readReceiptHandler.getGroupMessageReadMemberList(options).then(function (imResponse) {
            var _a = imResponse.data, isCompleted = _a.isCompleted, cursor = _a.cursor, messageID = _a.messageID, unreadUserIDList = _a.unreadUserIDList, readUserIDList = _a.readUserIDList;
            var ret = {
                code: 0,
                data: {
                    cursor: cursor,
                    isCompleted: isCompleted,
                    messageID: messageID,
                    unreadUserInfoList: [],
                    readUserInfoList: []
                }
            };
            var userIDList = __spreadArrays(unreadUserIDList, readUserIDList);
            if (userIDList.length === 0) {
                return ret;
            }
            return _this.getEngine().TUIUser.getUserProfile({ userIDList: userIDList }).then(function (res) {
                if (unreadUserIDList.length > 0) {
                    res.data.forEach(function (profile) {
                        var userID = profile.userID, _a = profile.nick, nick = _a === void 0 ? '' : _a, _b = profile.avatar, avatar = _b === void 0 ? '' : _b;
                        ret.data.unreadUserInfoList.push({ userID: userID, nick: nick, avatar: avatar });
                    });
                }
                else {
                    res.data.forEach(function (profile) {
                        var userID = profile.userID, _a = profile.nick, nick = _a === void 0 ? '' : _a, _b = profile.avatar, avatar = _b === void 0 ? '' : _b;
                        ret.data.readUserInfoList.push({ userID: userID, nick: nick, avatar: avatar });
                    });
                }
                return ret;
            });
        });
    };
    TUIChatService.prototype.downloadMergedMessages = function (message) {
        return this.getEngine().chat.downloadMergerMessage(message);
    };
    TUIChatService.prototype.setTranslationLanguage = function (language) {
        this.getEngine().TUIStore.update(const_1.StoreName.USER, 'targetLanguage', language);
    };
    TUIChatService.prototype.translateText = function (options) {
        var targetLanguage = this.getStoreData(const_1.StoreName.USER, 'targetLanguage');
        var params = __assign({ targetLanguage: targetLanguage, sourceLanguage: 'auto' }, options);
        return this.getEngine().chat.translateText(params);
    };
    TUIChatService.prototype.searchCloudMessages = function (options) {
        var conversationList = this.getStoreData(const_1.StoreName.CONV, 'conversationList');
        return this.getEngine().chat.searchCloudMessages(options).then(function (imResponse) {
            var searchResultList = imResponse.data.searchResultList;
            imResponse.data.searchResultList = searchResultList.map(function (searchResultItem) {
                var messageList = searchResultItem.messageList, conversationID = searchResultItem.conversationID, rest = __rest(searchResultItem, ["messageList", "conversationID"]);
                var messageModelList = messageList.map(function (message) { return new message_1["default"](message); });
                var conversation = conversationList.find(function (item) { return item.conversationID === conversationID; });
                return __assign(__assign({}, rest), { messageList: messageModelList.sort(function (a, b) { return b.time - a.time; }), conversation: conversation });
            });
            return imResponse;
        });
    };
    TUIChatService.prototype.addMessageReaction = function (message, reactionID) {
        return this.getEngine().chat.addMessageReaction(message.getMessage(), reactionID);
    };
    TUIChatService.prototype.removeMessageReaction = function (message, reactionID) {
        return this.getEngine().chat.removeMessageReaction(message.getMessage(), reactionID);
    };
    TUIChatService.prototype.getMessageReactions = function (options) {
        var _this = this;
        var _a = options.messageList, messageList = _a === void 0 ? [] : _a;
        var enabledEmojiPlugin = this.getStoreData(const_1.StoreName.APP, 'enabledEmojiPlugin');
        console.log("TUIChatService.getMessageReactions enabledEmojiPlugin:" + enabledEmojiPlugin + " messageList length:" + messageList.length);
        if (enabledEmojiPlugin && messageList.length > 0) {
            this.getEngine().chat.getMessageReactions(options).then(function (imResponse) {
                var resultList = imResponse.data.resultList || imResponse.data;
                _this.updateMessageReactionList(resultList);
            })["catch"](function () {
                // TODO: 此处不需要处理
            });
        }
    };
    TUIChatService.prototype.getAllUserListOfMessageReaction = function (options) {
        var _a;
        return this.getEngine().chat.getAllUserListOfMessageReaction(__assign(__assign({}, options), { message: (_a = options === null || options === void 0 ? void 0 : options.message) === null || _a === void 0 ? void 0 : _a.getMessage() }));
    };
    TUIChatService.prototype.updateMessageReactionList = function (list) {
        var _this = this;
        var toBeUpdatedMessageList = [];
        list.forEach(function (item) {
            var _a;
            var messageID = item.messageID, reactionList = item.reactionList;
            var message = _this.getEngine().TUIStore.getMessageModel(messageID);
            if (message) {
                var toBeAddedList = [];
                for (var i = 0; i < reactionList.length; i++) {
                    var addFlag = true;
                    for (var j = 0; j < message.reactionList.length; j++) {
                        if (reactionList[i].reactionID === message.reactionList[j].reactionID) {
                            message.reactionList[j] = reactionList[i];
                            addFlag = false;
                            break;
                        }
                    }
                    if (addFlag) {
                        toBeAddedList.push(reactionList[i]);
                    }
                }
                (_a = message.reactionList).push.apply(_a, toBeAddedList);
                toBeAddedList.length = 0;
                toBeUpdatedMessageList.push(message);
            }
        });
        if (toBeUpdatedMessageList.length > 0) {
            this.updateMessageList(toBeUpdatedMessageList, 'edit');
        }
    };
    TUIChatService.prototype.convertVoiceToText = function (options) {
        var message = options.message, _a = options.language, language = _a === void 0 ? 'zh' : _a;
        var _message = message.getMessage();
        return this.getEngine().chat.convertVoiceToText({
            message: _message,
            language: language
        });
    };
    TUIChatService.prototype.clearHistoryMessage = function (conversationID) {
        var chatEngine = this.getEngine();
        return chatEngine.chat.clearHistoryMessage(conversationID).then(function (imResponse) {
            chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'messageList', []);
            chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'nextReqMessageID', '');
            chatEngine.TUIStore.update(const_1.StoreName.CHAT, 'isCompleted', false);
            return imResponse;
        });
    };
    TUIChatService.prototype.updateMessageInfo = function (userInfo) {
        // userInfo ：{ 26825: { nick: 'aallen', namrCard: 'test01' }}
        // update userInfo to store.
        var localUserInfo = this.getStoreData(const_1.StoreName.CHAT, 'userInfo');
        this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'userInfo', Object.assign(localUserInfo, userInfo));
        // update nick and nameCard to store's messageList.
        var currentMessageList = this.getStoreData(const_1.StoreName.CHAT, 'messageList');
        if (currentMessageList.length > 0) {
            var flag = this.updateLocalMessage(currentMessageList, userInfo);
            if (flag) {
                this.getEngine().TUIStore.update(const_1.StoreName.CHAT, 'messageList', currentMessageList);
            }
        }
    };
    TUIChatService.prototype.updateLocalMessage = function (messageList, userInfo) {
        var flag = false;
        messageList.forEach(function (message) {
            if (userInfo[message.from]) {
                var _a = userInfo[message.from], nick = _a.nick, nameCard = _a.nameCard, avatar = _a.avatar;
                if (nick) {
                    message.nick = nick;
                    flag = true;
                }
                if (nameCard) {
                    message.nameCard = nameCard;
                    flag = true;
                }
                if (avatar) {
                    message.avatar = avatar;
                    flag = true;
                }
            }
        });
        return flag;
    };
    TUIChatService.prototype.handleC2CCallSignaling = function (messageList) {
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, myUserID, list;
            var _this = this;
            return __generator(this, function (_a) {
                chatEngine = this.getEngine();
                myUserID = chatEngine.getMyUserID();
                list = messageList.filter(function (message) { return __awaiter(_this, void 0, void 0, function () {
                    var conversationType, type, payload, isDisplayInChat, signalingInfo, callSignaling, customData, inviter, from, to, currentConversation, myProfile;
                    var _a, _b, _c, _d, _e;
                    return __generator(this, function (_f) {
                        switch (_f.label) {
                            case 0:
                                conversationType = message.conversationType, type = message.type, payload = message.payload;
                                isDisplayInChat = true;
                                if (!(conversationType === chatEngine.TYPES.CONV_C2C && type === chatEngine.TYPES.MSG_CUSTOM)) return [3 /*break*/, 2];
                                return [4 /*yield*/, chatEngine.chat.getSignalingInfo(message)];
                            case 1:
                                signalingInfo = _f.sent();
                                if (signalingInfo) {
                                    callSignaling = common_utils_1.JSONToObject(payload.data);
                                    // callSignaling(businessID = 1)
                                    if ((callSignaling === null || callSignaling === void 0 ? void 0 : callSignaling.businessID) === 1) {
                                        customData = common_utils_1.JSONToObject(callSignaling.data);
                                        isDisplayInChat = !(message._isExcludedFromUnreadCount && message._isExcludedFromLastMessage);
                                        if (isDisplayInChat) {
                                            // handle call signaling when it is not consumed
                                            if (((_a = customData === null || customData === void 0 ? void 0 : customData.data) === null || _a === void 0 ? void 0 : _a.consumed) !== true) {
                                                inviter = (_b = customData === null || customData === void 0 ? void 0 : customData.data) === null || _b === void 0 ? void 0 : _b.inviter;
                                                if ((customData === null || customData === void 0 ? void 0 : customData.line_busy) === 'line_busy' || ((_c = customData === null || customData === void 0 ? void 0 : customData.data) === null || _c === void 0 ? void 0 : _c.message) === 'lineBusy') {
                                                    inviter = callSignaling.inviter;
                                                }
                                                from = message.from, to = message.to;
                                                // reverse message: currentUser is not inviter
                                                if (inviter !== myUserID && message.from === myUserID) {
                                                    currentConversation = this.getStoreData(const_1.StoreName.CONV, 'currentConversation');
                                                    message.from = to;
                                                    message.to = from;
                                                    message.flow = 'in';
                                                    message.avatar = ((_d = currentConversation === null || currentConversation === void 0 ? void 0 : currentConversation.userProfile) === null || _d === void 0 ? void 0 : _d.avatar) || '';
                                                }
                                                // reverse message: currentUser is inviter
                                                if (inviter === myUserID && message.from !== myUserID) {
                                                    myProfile = this.getStoreData(const_1.StoreName.USER, 'userProfile');
                                                    message.from = to;
                                                    message.to = from;
                                                    message.flow = 'out';
                                                    message.avatar = myProfile === null || myProfile === void 0 ? void 0 : myProfile.avatar;
                                                }
                                                console.log(this.serv + ".handleC2CCallSignaling myUserID:" + myUserID + " callSignaling.inviter:" + callSignaling.inviter + " customData.data.inviter:" + ((_e = customData === null || customData === void 0 ? void 0 : customData.data) === null || _e === void 0 ? void 0 : _e.inviter));
                                            }
                                        }
                                    }
                                }
                                _f.label = 2;
                            case 2: return [2 /*return*/, isDisplayInChat];
                        }
                    });
                }); });
                return [2 /*return*/, list];
            });
        });
    };
    TUIChatService.prototype.sortMessageList = function (messageList) {
        var conversationType = messageList[0].conversationType;
        // C2C sort by time
        if (conversationType === this.getEngine().TYPES.CONV_C2C) {
            return messageList.sort(function (a, b) { return a.time - b.time; });
        }
        // GROUP sort by sequence
        var sortedMessageList = messageList.filter(function (item) { return item.status === 'success'; }).sort(function (a, b) { return a.sequence - b.sequence; });
        // Insert not success message into sortedList
        for (var i = 0; i < messageList.length; i++) {
            if (messageList[i].status !== 'success') {
                sortedMessageList.splice(i, 0, messageList[i]);
            }
        }
        return sortedMessageList;
    };
    return TUIChatService;
}(tui_base_1["default"]));
exports["default"] = TUIChatService;
