"use strict";

var __assign = void 0 && (void 0).__assign || function () {
  __assign = Object.assign || function (t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
      }
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

var __awaiter = void 0 && (void 0).__awaiter || function (thisArg, _arguments, P, generator) {
  function adopt(value) {
    return value instanceof P ? value : new P(function (resolve) {
      resolve(value);
    });
  }

  return new (P || (P = Promise))(function (resolve, reject) {
    function fulfilled(value) {
      try {
        step(generator.next(value));
      } catch (e) {
        reject(e);
      }
    }

    function rejected(value) {
      try {
        step(generator["throw"](value));
      } catch (e) {
        reject(e);
      }
    }

    function step(result) {
      result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
    }

    step((generator = generator.apply(thisArg, _arguments || [])).next());
  });
};

var __generator = void 0 && (void 0).__generator || function (thisArg, body) {
  var _ = {
    label: 0,
    sent: function sent() {
      if (t[0] & 1) throw t[1];
      return t[1];
    },
    trys: [],
    ops: []
  },
      f,
      y,
      t,
      g;
  return g = {
    next: verb(0),
    "throw": verb(1),
    "return": verb(2)
  }, typeof Symbol === "function" && (g[Symbol.iterator] = function () {
    return this;
  }), g;

  function verb(n) {
    return function (v) {
      return step([n, v]);
    };
  }

  function step(op) {
    if (f) throw new TypeError("Generator is already executing.");

    while (_) {
      try {
        if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
        if (y = 0, t) op = [op[0] & 2, t.value];

        switch (op[0]) {
          case 0:
          case 1:
            t = op;
            break;

          case 4:
            _.label++;
            return {
              value: op[1],
              done: false
            };

          case 5:
            _.label++;
            y = op[1];
            op = [0];
            continue;

          case 7:
            op = _.ops.pop();

            _.trys.pop();

            continue;

          default:
            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
              _ = 0;
              continue;
            }

            if (op[0] === 3 && (!t || op[1] > t[0] && op[1] < t[3])) {
              _.label = op[1];
              break;
            }

            if (op[0] === 6 && _.label < t[1]) {
              _.label = t[1];
              t = op;
              break;
            }

            if (t && _.label < t[2]) {
              _.label = t[2];

              _.ops.push(op);

              break;
            }

            if (t[2]) _.ops.pop();

            _.trys.pop();

            continue;
        }

        op = body.call(thisArg, _);
      } catch (e) {
        op = [6, e];
        y = 0;
      } finally {
        f = t = 0;
      }
    }

    if (op[0] & 5) throw op[1];
    return {
      value: op[0] ? op[1] : void 0,
      done: true
    };
  }
};

var __rest = void 0 && (void 0).__rest || function (s, e) {
  var t = {};

  for (var p in s) {
    if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
  }

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
};

exports.__esModule = true;

var chat_react_native_1 = require("@tencentcloud/chat-react-native");

var event_center_1 = require("./event-center");

var const_1 = require("../const");

var common_utils_1 = require("../utils/common-utils");

var config_1 = require("../config");

var tui_global_1 = require("../TUIGlobal/tui-global");

var optional_module_1 = require("../const/optional-module");

var ChatEngine =
/** @class */
function () {
  function ChatEngine() {
    this.EVENT = chat_react_native_1["default"].EVENT;
    this.TYPES = chat_react_native_1["default"].TYPES;
    this.loginStatusPromise = new Map();
    this.userID = '';
    this.SDKAppID = 0;
    this.userSig = '';
    this.isInited = false;
  }
  /**
   * 获取 ChatEngine 实例
  */


  ChatEngine.getInstance = function () {
    if (!ChatEngine.instance) {
      ChatEngine.instance = new ChatEngine();
    }

    return ChatEngine.instance;
  };

  ChatEngine.prototype.mount = function (name, instance) {
    this[name] = instance;
  };

  ChatEngine.prototype.login = function (options) {
    return __awaiter(this, void 0, void 0, function () {
      var chat, SDKAppID, userID, userSig, isOfficial;

      var _this = this;

      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            chat = options.chat, SDKAppID = options.SDKAppID, userID = options.userID, userSig = options.userSig;
            isOfficial = SDKAppID === 1400187352 || SDKAppID === 1400188366;
            return [4
            /*yield*/
            , this.createChat(options)];

          case 1:
            _a.sent();

            this.userID = userID;
            this.SDKAppID = SDKAppID;
            this.userSig = userSig;
            tui_global_1["default"].getInstance().initOfficial(isOfficial); // 兼容低版本 uikit

            this.TUIStore.update(const_1.StoreName.APP, 'isOfficial', isOfficial);
            this.TUIStore.update(const_1.StoreName.APP, 'SDKVersion', chat_react_native_1["default"].VERSION);
            this.eventCenter = new event_center_1["default"](this);
            this.eventCenter.removeEvents(); // 移除注册的事件监听，避免重复注册

            this.resetStore();
            this.initService();

            if (chat && chat.isReady()) {
              console.log('TUIChatEngine.login ok, from TUICore.');
              this.TUIUser.getUserProfile();
              this.checkCommercialAbility();
              return [2
              /*return*/
              , Promise.resolve({})];
            }

            this.registerPlugin(options);
            this.eventCenter.addEvent(this.EVENT.SDK_READY, function () {
              _this.onSDKReady();
            });
            this.eventCenter.addEvent(this.EVENT.SDK_NOT_READY, function () {
              _this.onSDKNotReady();
            });
            return [2
            /*return*/
            , this.loginChat(options)];
        }
      });
    });
  };

  ChatEngine.prototype.logout = function () {
    this.userID = '';
    this.isInited = false;
    this.resetStore();
    return this.chat.logout();
  };

  ChatEngine.prototype.isReady = function () {
    var _a;

    return ((_a = this.chat) === null || _a === void 0 ? void 0 : _a.isReady()) || false;
  };

  ChatEngine.prototype.setLogLevel = function (level) {
    if (!this.chat) {
      console.warn('TUIChatEngine 初始化未完成，请确认 TUIChatEngine.login 接口调用是否正常。');
      return;
    }

    this.chat.setLogLevel(level);
  };

  ChatEngine.prototype.destroy = function () {
    // 解绑 IM 事件
    this.eventCenter.unbindIMEvents();
    this.isInited = false;
    this.resetStore();
    return this.chat.destroy();
  };

  ChatEngine.prototype.getMyUserID = function () {
    return this.userID;
  };

  ChatEngine.prototype.getContext = function () {
    return {
      chat: this.chat,
      userID: this.userID,
      SDKAppID: this.SDKAppID,
      userSig: this.userSig
    };
  };
  /**
   * 重置 Store
  */


  ChatEngine.prototype.resetStore = function () {
    this.TUIStore.reset(const_1.StoreName.CHAT);
    this.TUIStore.reset(const_1.StoreName.CONV);
    this.TUIStore.reset(const_1.StoreName.GRP);
    this.TUIStore.reset(const_1.StoreName.USER);
    this.TUIStore.reset(const_1.StoreName.SEARCH);
    this.TUIStore.reset(const_1.StoreName.FRIEND);
    this.TUIStore.reset(const_1.StoreName.CUSTOM);
    console.log('TUIChatEngine.resetStore ok.');
  };
  /**
   * 初始化 Service
  */


  ChatEngine.prototype.initService = function () {
    this.TUIChat.init();
    this.TUIConversation.init();
    this.TUIUser.init();
    this.initOptionalServices();
    this.isInited = true;
    console.log('TUIChatEngine.initService ok.');
  };

  ChatEngine.prototype.initOptionalServices = function () {
    return __awaiter(this, void 0, void 0, function () {
      var version, arr;
      return __generator(this, function (_a) {
        switch (_a.label) {
          case 0:
            version = chat_react_native_1["default"].VERSION;
            arr = version.split('.');
            if (!(arr[0] > 3 || arr[0] === 3 && arr[1] >= 3 && arr[2] > 0)) return [3
            /*break*/
            , 3];
            return [4
            /*yield*/
            , this.chat.callExperimentalAPI('canIUseModule', [optional_module_1["default"].GRP])];

          case 1:
            if (_a.sent() === true) {
              this.TUIGroup.init();
            }

            return [4
            /*yield*/
            , this.chat.callExperimentalAPI('canIUseModule', [optional_module_1["default"].SNS])];

          case 2:
            if (_a.sent() === true) {
              this.TUIFriend.init();
            }

            return [3
            /*break*/
            , 4];

          case 3:
            this.TUIGroup.init();
            this.TUIFriend.init();
            _a.label = 4;

          case 4:
            return [2
            /*return*/
            ];
        }
      });
    });
  };

  ChatEngine.prototype.createChat = function (options) {
    return __awaiter(this, void 0, void 0, function () {
      var chat, rest, _a;

      return __generator(this, function (_b) {
        switch (_b.label) {
          case 0:
            chat = options.chat, rest = __rest(options, ["chat"]);

            if (this.chat != undefined) {
              return [2
              /*return*/
              ];
            }

            if (!common_utils_1.isUndefined(chat)) {
              this.chat = chat;
              return [2
              /*return*/
              ];
            }

            _a = this;
            return [4
            /*yield*/
            , chat_react_native_1["default"].create(__assign(__assign({}, rest), {
              scene: 'chat-uikit-engine'
            }))];

          case 1:
            _a.chat = _b.sent();
            return [2
            /*return*/
            ];
        }
      });
    });
  };

  ChatEngine.prototype.loginChat = function (options) {
    var _this = this;

    var userID = options.userID,
        userSig = options.userSig;
    return new Promise(function (resolve, reject) {
      _this.chat.login({
        userID: userID,
        userSig: userSig
      }).then(function (imResponse) {
        _this.checkCommercialAbility();

        if (imResponse.data.repeatLogin && _this.chat.isReady()) {
          resolve(imResponse);
        }

        _this.loginStatusPromise.set('login', {
          resolve: resolve,
          reject: reject,
          imResponse: imResponse
        });
      })["catch"](function (error) {
        reject(error);
      });
    });
  };
  /**
   * 注册插件，用于文件上传、本地审核、离线推送插件
  */


  ChatEngine.prototype.registerPlugin = function (options) {// const {
    //   useUploadPlugin = false,
    //   useProfanityFilterPlugin = false,
    //   TIMPush = undefined,
    //   pushConfig = undefined,
    //   TUIOfflinePush = undefined,
    //   offlinePushConfig = undefined,
    // } = options;
    // if (useUploadPlugin === true) {
    //   this.chat.registerPlugin({ 'tim-upload-plugin': TIMUploadPlugin });
    // }
    // if (useProfanityFilterPlugin === true) {
    //   this.chat.registerPlugin({ 'tim-profanity-filter-plugin': TIMProfanityFilterPlugin });
    // }
    // // uniApp 打包小程序时 IN_UNI_NATIVE_APP 为 true，所以此处需要增加条件
    // if (IN_UNI_NATIVE_APP && !IN_WX_MINI_APP && !isUndefined(TIMPush) && !isUndefined(pushConfig)) {
    //   this.chat.registerPlugin({ 'tim-push': TIMPush, pushConfig });
    // }
    // // uniApp 打包小程序时 IN_UNI_NATIVE_APP 为 true，所以此处需要增加条件
    // if (IN_UNI_NATIVE_APP && !IN_WX_MINI_APP && !isUndefined(TUIOfflinePush) && !isUndefined(offlinePushConfig)) {
    //   this.chat.registerPlugin({ 'tim-offline-push-plugin': TUIOfflinePush, offlinePushConfig });
    // }
  };

  ChatEngine.prototype.onSDKReady = function () {
    if (this.loginStatusPromise.has('login')) {
      var handler = this.loginStatusPromise.get('login');
      handler.resolve(handler.imResponse); // 独立使用 engine 登录成功 SDK Ready 后获取一次自己的资料

      this.TUIUser.getUserProfile();
    }

    this.loginStatusPromise["delete"]('login');
  };

  ChatEngine.prototype.onSDKNotReady = function () {
    if (this.loginStatusPromise.has('login')) {
      var handler = this.loginStatusPromise.get('login');
      handler.reject(new Error('sdk not ready'));
    }

    this.loginStatusPromise["delete"]('login');
    this.resetStore();
  }; // 登录成功后校验商业化能力位


  ChatEngine.prototype.checkCommercialAbility = function () {
    var _this = this;

    Object.keys(config_1.commercialAbility).forEach(function (key) {
      var ability = config_1.commercialAbility[key];

      _this.chat.callExperimentalAPI('isCommercialAbilityEnabled', ability).then(function (imResponse) {
        var _a = imResponse.data.enabled,
            enabled = _a === void 0 ? false : _a;

        _this.TUIStore.update(const_1.StoreName.APP, key, enabled);
      });
    });
  };

  return ChatEngine;
}();

exports["default"] = ChatEngine;