"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
var tui_base_1 = require("../tui-base");
var const_1 = require("../const");
var common_utils_1 = require("../utils/common-utils");
var TUIGroupService = /** @class */ (function (_super) {
    __extends(TUIGroupService, _super);
    function TUIGroupService() {
        var _this = _super.call(this) || this;
        _this.groupMap = new Map();
        return _this;
    }
    /**
     * 获取 TUIGroupService 实例
    */
    TUIGroupService.getInstance = function () {
        if (!TUIGroupService.instance) {
            TUIGroupService.instance = new TUIGroupService();
        }
        return TUIGroupService.instance;
    };
    /**
     * 初始化 Service
     */
    TUIGroupService.prototype.init = function () {
        var chatEngine = this.getEngine();
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.GROUP_LIST_UPDATED, this.onGroupListUpdated.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.GROUP_ATTRIBUTES_UPDATED, this.onGroupAttributesUpdated.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.GROUP_COUNTER_UPDATED, this.onGroupCounterUpdated.bind(this));
        chatEngine.eventCenter.addEvent(chatEngine.EVENT.MESSAGE_RECEIVED, this.onMessageReceived.bind(this));
        this.getGroupInitData();
    };
    TUIGroupService.prototype.onGroupListUpdated = function (groupList) {
        var chatEngine = this.getEngine();
        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'groupList', groupList);
        var currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
        groupList.forEach(function (item) {
            if (item.groupID === currentGroupID) {
                chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroup', item);
            }
        });
    };
    TUIGroupService.prototype.onGroupAttributesUpdated = function (data) {
        var chatEngine = this.getEngine();
        var currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
        var groupList = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'groupList');
        var groupID = data.groupID, groupAttributes = data.groupAttributes;
        if (currentGroupID === groupID) {
            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupAttributes', groupAttributes);
        }
        groupList = groupList.map(function (item) {
            if (item.groupID === groupID) {
                item.groupAttributes = groupAttributes;
            }
            return item;
        });
        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'groupList', groupList);
    };
    TUIGroupService.prototype.onGroupCounterUpdated = function (data) {
        var chatEngine = this.getEngine();
        var currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
        var currentGroupCounters = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupCounters') || {};
        var groupList = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'groupList');
        var groupID = data.groupID, key = data.key, value = data.value;
        if (currentGroupID === groupID) {
            currentGroupCounters[key] = value;
            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupCounters', currentGroupCounters);
        }
        groupList = groupList.map(function (item) {
            var _a;
            if (item.groupID === groupID) {
                item.groupCounters = __assign(__assign({}, item.groupCounters), (_a = {}, _a[key] = value, _a));
            }
            return item;
        });
        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'groupList', groupList);
    };
    TUIGroupService.prototype.onMessageReceived = function (messageList) {
        var _this = this;
        var chatEngine = this.getEngine();
        var groupSystemNoticeList = [];
        messageList.forEach(function (message) {
            var _a;
            if (message.type === chatEngine.TYPES.MSG_GRP_TIP) {
                var payload = message.payload;
                var operationType = payload.operationType, userIDList = payload.userIDList;
                var groupID = _this.getEngine().TUIStore.getData(const_1.StoreName.GRP, "currentGroupID");
                _this.getGroupProfile({ groupID: groupID });
                switch (operationType) {
                    case chatEngine.TYPES.GRP_TIP_MBR_JOIN:
                        _this.addMemberList(userIDList);
                        break;
                    case chatEngine.TYPES.GRP_TIP_MBR_QUIT:
                        if ((_a = payload.operatorInfo) === null || _a === void 0 ? void 0 : _a.userID)
                            _this.removeMemberList([payload.operatorInfo.userID]);
                        break;
                    case chatEngine.TYPES.GRP_TIP_MBR_KICKED_OUT:
                        _this.removeMemberList(userIDList);
                        break;
                    case chatEngine.TYPES.GRP_TIP_MBR_SET_ADMIN:
                        _this.updateGroupMember(userIDList);
                        break;
                    case chatEngine.TYPES.GRP_TIP_MBR_CANCELED_ADMIN:
                        _this.updateGroupMember(userIDList);
                        break;
                    case chatEngine.TYPES.GRP_TIP_GRP_PROFILE_UPDATED:
                        // v2.3.3, update currentGroup by GROUP_LIST_UPDATED when group profile is updated.
                        break;
                    case chatEngine.TYPES.GRP_TIP_MBR_PROFILE_UPDATED:
                        _this.updateGroupMember(userIDList);
                        break;
                    case chatEngine.TYPES.GRP_TIP_BAN_AVCHATROOM_MEMBER:
                        _this.updateGroupMember(userIDList);
                        break;
                    case chatEngine.TYPES.GRP_TIP_UNBAN_AVCHATROOM_MEMBER:
                        _this.updateGroupMember(userIDList);
                        break;
                    default:
                        break;
                }
            }
            if (message.type === chatEngine.TYPES.MSG_GRP_SYS_NOTICE) {
                groupSystemNoticeList.push(message);
            }
        });
        if (groupSystemNoticeList.length > 0) {
            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'groupSystemNoticeList', groupSystemNoticeList);
        }
    };
    TUIGroupService.prototype.onGroupSystemNoticeListUpdated = function (data) {
        var groupSystemNoticeList = [];
        var groupID = data.groupID;
        var chatEngine = this.getEngine();
        var sysMsg = new Message();
        sysMsg.ID = 'Group' + groupID + Date.now();
        sysMsg.type = chatEngine.TYPES.MSG_GRP_SYS_NOTICE;
        sysMsg.conversationID = 'Group' + groupID;
        sysMsg.conversationType = chatEngine.TYPES.
            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'groupSystemNoticeList', groupSystemNoticeList);
    };
    TUIGroupService.prototype.getGroupInitData = function () {
        var _this = this;
        var chatEngine = this.getEngine();
        // TUIChatEngine 无 UI 集成时不需要执行此逻辑
        if (!chatEngine.chat.isReady()) {
            return;
        }
        chatEngine.chat.getGroupList().then(function (imResponse) {
            var _a = imResponse.data.groupList, groupList = _a === void 0 ? [] : _a;
            console.log("TUIGroupService.init, getGroupList count:" + groupList.length);
            if (groupList.length > 0) {
                _this.onGroupListUpdated(groupList);
            }
        });
    };
    TUIGroupService.prototype.updateGroupMember = function (userIDList) {
        return __awaiter(this, void 0, void 0, function () {
            var groupID, imResponse, memberList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        groupID = this.getEngine().TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
                        if (!groupID) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getGroupMemberProfile({
                                groupID: groupID,
                                userIDList: userIDList
                            })];
                    case 1:
                        imResponse = _a.sent();
                        memberList = imResponse.data.memberList;
                        this.updateMemberList(memberList);
                        _a.label = 2;
                    case 2: return [2 /*return*/];
                }
            });
        });
    };
    TUIGroupService.prototype.resetCurrentStore = function () {
        var keyList = [
            'currentGroupID',
            'currentGroup',
            'currentGroupAttributes',
            'currentGroupCounters',
            'currentGroupMemberList',
        ];
        this.getEngine().TUIStore.reset(const_1.StoreName.GRP, keyList, true);
    };
    TUIGroupService.prototype.switchGroup = function (groupID) {
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, conversation, currentGroup_1, currentGroupID, currentGroup_2, error_1, timer, currentGroup;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chatEngine = this.getEngine();
                        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'offset', 0);
                        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'isCompleted', false);
                        conversation = chatEngine.TUIStore.getConversationModel("GROUP" + groupID);
                        // operationType > 0 说明用户已经不在群组内了，直接返回
                        if ((conversation === null || conversation === void 0 ? void 0 : conversation.operationType) > 0) {
                            currentGroup_1 = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroup');
                            return [2 /*return*/, Promise.resolve(currentGroup_1)];
                        }
                        currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
                        if (!groupID) {
                            this.resetCurrentStore();
                            return [2 /*return*/, Promise.resolve({})];
                        }
                        if (currentGroupID === groupID) {
                            currentGroup_2 = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroup');
                            return [2 /*return*/, Promise.resolve(currentGroup_2)];
                        }
                        this.resetCurrentStore();
                        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupID', groupID);
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getGroupInfo(groupID)];
                    case 2:
                        _a.sent();
                        return [3 /*break*/, 4];
                    case 3:
                        error_1 = _a.sent();
                        Promise.reject(error_1);
                        return [3 /*break*/, 4];
                    case 4:
                        timer = setTimeout(function () {
                            _this.groupMap["delete"](groupID);
                            clearTimeout(timer);
                        }, 5000);
                        currentGroup = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroup');
                        return [2 /*return*/, Promise.resolve(currentGroup)];
                }
            });
        });
    };
    TUIGroupService.prototype.getGroupInfo = function (groupID) {
        return __awaiter(this, void 0, void 0, function () {
            var chatEngine, currentGroupMap, groupInfo, group, memberList, attributesRes, groupAttributes, countersRes, counters, error_2;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        chatEngine = this.getEngine();
                        currentGroupMap = this.groupMap.get(groupID);
                        if (currentGroupMap) {
                            this.updateMemberList((currentGroupMap === null || currentGroupMap === void 0 ? void 0 : currentGroupMap.memberList) || []);
                            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroup', currentGroupMap.group);
                            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupAttributes', currentGroupMap.groupAttributes || {});
                            chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupCounters', currentGroupMap.counters || {});
                            return [2 /*return*/];
                        }
                        groupInfo = {
                            group: {},
                            memberList: [],
                            groupAttributes: undefined,
                            counters: undefined
                        };
                        return [4 /*yield*/, this.getGroupProfile({ groupID: groupID })];
                    case 1:
                        group = (_a.sent()).data.group;
                        groupInfo.group = group;
                        return [4 /*yield*/, this.getGroupMemberList({ groupID: groupID })];
                    case 2:
                        memberList = (_a.sent()).data.memberList;
                        groupInfo.memberList = memberList;
                        return [4 /*yield*/, this.getGroupAttributes({ groupID: groupID, keyList: [] })];
                    case 3:
                        attributesRes = _a.sent();
                        groupAttributes = attributesRes.data.groupAttributes;
                        groupInfo.groupAttributes = groupAttributes;
                        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupAttributes', groupAttributes);
                        _a.label = 4;
                    case 4:
                        _a.trys.push([4, 6, , 7]);
                        return [4 /*yield*/, this.getGroupCounters({ groupID: groupID, keyList: [] })];
                    case 5:
                        countersRes = _a.sent();
                        counters = countersRes.data.counters;
                        groupInfo.counters = counters;
                        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupCounters', counters);
                        return [3 /*break*/, 7];
                    case 6:
                        error_2 = _a.sent();
                        console.warn(error_2 === null || error_2 === void 0 ? void 0 : error_2.message); // 旗舰功能，预防初次跑通（直接打印 error uni 打包小程序会报错）
                        return [3 /*break*/, 7];
                    case 7:
                        this.groupMap.set(groupID, groupInfo);
                        return [2 /*return*/];
                }
            });
        });
    };
    TUIGroupService.prototype.getGroupProfile = function (options) {
        var _this = this;
        var chatEngine = this.getEngine();
        return chatEngine.chat.getGroupProfile(options).then(function (imResponse) { return __awaiter(_this, void 0, void 0, function () {
            var currentGroupID, group;
            return __generator(this, function (_a) {
                currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
                if (currentGroupID === options.groupID) {
                    group = imResponse.data.group;
                    chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroup', group);
                }
                return [2 /*return*/, imResponse];
            });
        }); });
    };
    TUIGroupService.prototype.updateGroupProfile = function (options) {
        var _this = this;
        return this.getEngine().chat.updateGroupProfile(options).then(function (res) {
            _this.getEngine().TUIStore.update(const_1.StoreName.GRP, 'currentGroup', res.data.group);
        });
    };
    TUIGroupService.prototype.createGroup = function (options) {
        return this.getEngine().chat.createGroup(options);
    };
    TUIGroupService.prototype.dismissGroup = function (groupID) {
        return this.getEngine().chat.dismissGroup(groupID);
    };
    TUIGroupService.prototype.searchGroupByID = function (groupID) {
        var chatEngine = this.getEngine();
        return chatEngine.chat.searchGroupByID(groupID).then(function (imResponse) {
            var group = imResponse.data.group;
            var groupList = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'groupList');
            imResponse.data.group.isJoinedGroup = groupList.some(function (item) { return item.groupID === group.groupID; });
            return imResponse;
        });
    };
    TUIGroupService.prototype.joinGroup = function (options) {
        return this.getEngine().chat.joinGroup(options);
    };
    TUIGroupService.prototype.quitGroup = function (groupID) {
        return this.getEngine().chat.quitGroup(groupID);
    };
    TUIGroupService.prototype.getGroupApplicationList = function () {
        return this.getEngine().chat.getGroupApplicationList();
    };
    TUIGroupService.prototype.handleGroupApplication = function (options) {
        return this.getEngine().chat.handleGroupApplication(options);
    };
    TUIGroupService.prototype.getGroupOnlineMemberCount = function (groupID) {
        return this.getEngine().chat.getGroupOnlineMemberCount(groupID);
    };
    TUIGroupService.prototype.changeGroupOwner = function (options) {
        return this.getEngine().chat.changeGroupOwner(options);
    };
    TUIGroupService.prototype.initGroupAttributes = function (options) {
        return this.getEngine().chat.initGroupAttributes(options);
    };
    TUIGroupService.prototype.setGroupAttributes = function (options) {
        return this.getEngine().chat.setGroupAttributes(options);
    };
    TUIGroupService.prototype.deleteGroupAttributes = function (options) {
        return this.getEngine().chat.deleteGroupAttributes(options);
    };
    TUIGroupService.prototype.getGroupAttributes = function (options) {
        return this.getEngine().chat.getGroupAttributes(options);
    };
    TUIGroupService.prototype.setGroupCounters = function (options) {
        return this.getEngine().chat.setGroupCounters(options);
    };
    TUIGroupService.prototype.increaseGroupCounter = function (options) {
        return this.getEngine().chat.increaseGroupCounter(options);
    };
    TUIGroupService.prototype.decreaseGroupCounter = function (options) {
        return this.getEngine().chat.decreaseGroupCounter(options);
    };
    TUIGroupService.prototype.getGroupCounters = function (options) {
        return this.getEngine().chat.getGroupCounters(options);
    };
    // group member
    TUIGroupService.prototype.updateMemberList = function (memberList) {
        var chatEngine = this.getEngine();
        var currentGroupMemberList = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupMemberList') || [];
        var filterMemberList = currentGroupMemberList.filter(function (currentMember) {
            var isExist = memberList.find(function (member) { return member.userID === currentMember.userID; });
            return !isExist;
        });
        var newMemberList = __spreadArrays(filterMemberList, memberList);
        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupMemberList', newMemberList);
    };
    TUIGroupService.prototype.addMemberList = function (userIDList) {
        return __awaiter(this, void 0, void 0, function () {
            var groupID, imResponse, memberList, error_3, memberList;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        groupID = this.getEngine().TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
                        if (!groupID) return [3 /*break*/, 4];
                        _a.label = 1;
                    case 1:
                        _a.trys.push([1, 3, , 4]);
                        return [4 /*yield*/, this.getGroupMemberProfile({
                                groupID: groupID,
                                userIDList: userIDList
                            })];
                    case 2:
                        imResponse = _a.sent();
                        memberList = imResponse.data.memberList;
                        this.updateMemberList(memberList);
                        return [3 /*break*/, 4];
                    case 3:
                        error_3 = _a.sent();
                        memberList = userIDList.map(function (userID) {
                            var GroupMember = {
                                userID: userID,
                                avatar: '',
                                nick: '',
                                role: '',
                                joinTime: 0,
                                nameCard: '',
                                muteUntil: 0,
                                memberCustomField: [],
                                isOnline: true
                            };
                            return GroupMember;
                        });
                        this.updateMemberList(memberList);
                        return [3 /*break*/, 4];
                    case 4: return [2 /*return*/];
                }
            });
        });
    };
    TUIGroupService.prototype.removeMemberList = function (userIDList) {
        var chatEngine = this.getEngine();
        var currentGroupMemberList = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupMemberList');
        var newMemberList = currentGroupMemberList.filter(function (member) { return userIDList.indexOf(member.userID) === -1; });
        chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroupMemberList', newMemberList);
    };
    TUIGroupService.prototype.getGroupMemberList = function (options) {
        var _this = this;
        var chatEngine = this.getEngine();
        if (common_utils_1.isUndefined(options.offset)) {
            var _offset = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'offset');
            options.offset = _offset;
        }
        return chatEngine.chat.getGroupMemberList(options).then(function (imResponse) {
            var currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
            if (currentGroupID === options.groupID) {
                var _a = imResponse.data, memberList = _a.memberList, _b = _a.offset, offset = _b === void 0 ? 0 : _b;
                _this.updateMemberList(memberList);
                chatEngine.TUIStore.update(const_1.StoreName.GRP, 'offset', offset);
                if (offset === 0) {
                    chatEngine.TUIStore.update(const_1.StoreName.GRP, 'isCompleted', true);
                }
            }
            return imResponse;
        });
    };
    TUIGroupService.prototype.getGroupMemberProfile = function (options) {
        return this.getEngine().chat.getGroupMemberProfile(options);
    };
    TUIGroupService.prototype.addGroupMember = function (options) {
        var _this = this;
        var chatEngine = this.getEngine();
        return chatEngine.chat.addGroupMember(options).then(function (imResponse) { return __awaiter(_this, void 0, void 0, function () {
            var currentGroupID, _a, successUserIDList, group;
            return __generator(this, function (_b) {
                currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
                if (currentGroupID === options.groupID) {
                    _a = imResponse.data, successUserIDList = _a.successUserIDList, group = _a.group;
                    chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroup', group);
                    this.addMemberList(successUserIDList);
                }
                return [2 /*return*/, imResponse];
            });
        }); });
    };
    TUIGroupService.prototype.deleteGroupMember = function (options) {
        var _this = this;
        var chatEngine = this.getEngine();
        return chatEngine.chat.deleteGroupMember(options).then(function (imResponse) {
            var currentGroupID = chatEngine.TUIStore.getData(const_1.StoreName.GRP, 'currentGroupID');
            if (currentGroupID === options.groupID) {
                var _a = imResponse.data, userIDList = _a.userIDList, group = _a.group;
                _this.removeMemberList(userIDList);
                chatEngine.TUIStore.update(const_1.StoreName.GRP, 'currentGroup', group);
            }
            return imResponse;
        });
    };
    TUIGroupService.prototype.setGroupMemberMuteTime = function (options) {
        var _this = this;
        return this.getEngine().chat.setGroupMemberMuteTime(options).then(function (res) {
            _this.updateMemberList([res.data.member]);
            _this.getEngine().TUIStore.update(const_1.StoreName.GRP, 'currentGroup', res.data.group);
        });
    };
    TUIGroupService.prototype.setGroupMemberRole = function (options) {
        var _this = this;
        return this.getEngine().chat.setGroupMemberRole(options).then(function (res) {
            _this.updateMemberList([res.data.member]);
            _this.getEngine().TUIStore.update(const_1.StoreName.GRP, 'currentGroup', res.data.group);
        });
    };
    TUIGroupService.prototype.setGroupMemberNameCard = function (options) {
        var _this = this;
        return this.getEngine().chat.setGroupMemberNameCard(options).then(function (res) {
            _this.updateMemberList([res.data.member]);
            _this.getEngine().TUIStore.update(const_1.StoreName.GRP, 'currentGroup', res.data.group);
        });
    };
    TUIGroupService.prototype.setGroupMemberCustomField = function (options) {
        var _this = this;
        return this.getEngine().chat.setGroupMemberCustomField(options).then(function (res) {
            _this.updateMemberList([res.data.member]);
            _this.getEngine().TUIStore.update(const_1.StoreName.GRP, 'currentGroup', res.data.group);
        });
    };
    TUIGroupService.prototype.markGroupMemberList = function (options) {
        return this.getEngine().chat.markGroupMemberList(options);
    };
    return TUIGroupService;
}(tui_base_1["default"]));
exports["default"] = TUIGroupService;
