"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
exports.__esModule = true;
var group_1 = require("../../model/group");
var GroupStore = /** @class */ (function () {
    function GroupStore() {
        this.defaultStore = {
            currentGroupID: '',
            currentGroup: {},
            currentGroupAttributes: {},
            currentGroupCounters: {},
            currentGroupMemberList: [],
            groupList: [],
            groupSystemNoticeList: [],
            isCompleted: false,
            offset: 0
        };
        this.store = {
            currentGroupID: '',
            currentGroup: undefined,
            currentGroupAttributes: {},
            currentGroupCounters: {},
            currentGroupMemberList: [],
            groupList: [],
            groupSystemNoticeList: [],
            isCompleted: false,
            offset: 0
        };
    }
    GroupStore.prototype.update = function (key, data) {
        switch (key) {
            case 'groupList':
                this.updateGroupList(data);
                break;
            case 'currentGroup':
                if (data instanceof group_1["default"]) {
                    this.store.currentGroup = data;
                }
                else {
                    this.store.currentGroup = new group_1["default"](data);
                }
                break;
            default:
                this.store[key] = data;
        }
    };
    GroupStore.prototype.getData = function (key) {
        if (key === 'groupSystemNoticeList') {
            var groupSystemNoticeList = __spreadArrays(this.store.groupSystemNoticeList);
            // 群系统通知给 UI 后立即清空
            this.store.groupSystemNoticeList.length = 0;
            return groupSystemNoticeList;
        }
        return this.store[key];
    };
    GroupStore.prototype.reset = function (keyList) {
        var _this = this;
        if (keyList === void 0) { keyList = []; }
        this.store = __assign(__assign(__assign({}, this.defaultStore), this.store), keyList.reduce(function (acc, key) {
            var _a;
            return (__assign(__assign({}, acc), (_a = {}, _a[key] = _this.defaultStore[key], _a)));
        }, {}));
    };
    GroupStore.prototype.updateGroupList = function (list) {
        this.store.groupList = list.map(function (item) {
            if (item instanceof group_1["default"]) {
                return item;
            }
            return new group_1["default"](item);
        });
    };
    return GroupStore;
}());
exports["default"] = GroupStore;
